%define rev 20041110

Summary:     Synchronizing Key Server
Name:        sks
Version:     1.0.9
Release:     %{rev}.pp
License:     GPL
Group:       System Environment/Daemons
Source0:     http://sks.dnsalias.net/distribution/%{name}-%{version}-%{rev}.tgz
Source1:     sksconf
Patch0:      %{name}-%{version}-config.patch
URL:         http://www.nongnu.org/%{name}/
Buildroot:   /var/tmp/%{name}-root
Vendor:      Yaron M. Minsky <yminsky@cs.cornell.edu>
Packager:    Peter Pramberger <peter.pramberger@member.fsf.org>
Provides:    %{name}.pp
Requires:    db4 >= 4.2 ocaml = 3.07-2 ncurses zlib
Prereq:      /bin/bash /usr/sbin/useradd /usr/sbin/groupadd
BuildPrereq: gcc >= 2.96 /bin/mkdir /usr/bin/make /usr/bin/install
BuildPrereq: /bin/chmod ocaml = 3.07-2 db4-devel >= 4.2 ncurses-devel
BuildPrereq: zlib-devel
ExclusiveOS: linux


%description
SKS (Synchronizing Key Server) is a full-featured replacement
for the standard PKS OpenPGP Key Server. It matches all of PKS
features and interfaces, and at the same time provides a highly
efficient, gossip-based replication algorithm that ensures that
the replication is complete.


%prep
%setup -q -n %{name}
%patch0 -p1 -b .config
cp -f contrib/redhat/Makefile.local .


%build
export CFLAGS="$RPM_OPT_FLAGS"
export CPPFLAGS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS"
make dep
make all all.bc


# Do not strip, only compress documentation
%define __os_install_post /usr/lib/rpm/brp-compress


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/var/lib/sks/web
make \
	PREFIX=$RPM_BUILD_ROOT/usr           \
	MANDIR=$RPM_BUILD_ROOT/usr/share/man \
	CONFDIR=$RPM_BUILD_ROOT/etc/sks      \
	LOGDIR=$RPM_BUILD_ROOT/var/log/sks   \
	WORKDIR=$RPM_BUILD_ROOT/var/lib/sks  \
	install install.bc
ln -s /usr/bin/sks $RPM_BUILD_ROOT/usr/sbin/sks-db
ln -s /usr/bin/sks $RPM_BUILD_ROOT/usr/sbin/sks-recon
ln -s /usr/bin/sks.bc $RPM_BUILD_ROOT/usr/sbin/sks-db.bc
ln -s /usr/bin/sks.bc $RPM_BUILD_ROOT/usr/sbin/sks-recon.bc
install -m 0755 contrib/redhat/sks-db.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sks-db
install -m 0755 contrib/redhat/sks-recon.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sks-recon
install -m 0644 contrib/redhat/sks.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/sks
install -m 0644 contrib/redhat/sks.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/sks
install -m 0640 contrib/redhat/sks.procmailrc $RPM_BUILD_ROOT/var/lib/sks/.procmailrc
install -m 0640 %{SOURCE1} $RPM_BUILD_ROOT/etc/sks/
touch $RPM_BUILD_ROOT/etc/sks/mailsync
touch $RPM_BUILD_ROOT/etc/sks/membership
chmod a-x $RPM_BUILD_ROOT/usr/share/man/man8/*
rm -f $RPM_BUILD_ROOT/usr/bin/sks_*build.sh
rm -f $RPM_BUILD_ROOT/usr/bin/sks_*build.bc.sh


%pre
if ! grep sks /etc/group > /dev/null 2>&1; then
   /usr/sbin/groupadd sks > /dev/null 2>&1
fi
if ! grep sks /etc/passwd > /dev/null 2>&1; then
   /usr/sbin/useradd -g sks -G sks -d /var/lib/sks \
        -r -s /bin/bash sks > /dev/null 2>&1
fi


%post
/sbin/chkconfig --add sks-db
/sbin/chkconfig sks-db on
/sbin/chkconfig --add sks-recon
/sbin/chkconfig sks-recon on
if [ -f /var/lock/subsys/sks-db ]; then
   /etc/rc.d/init.d/sks-db restart
fi
if [ -f /var/lock/subsys/sks-recon ]; then
   /etc/rc.d/init.d/sks-recon restart
fi


%preun
if [ $1 = 0 ] ; then
   /sbin/chkconfig sks-recon off
   /sbin/chkconfig --del sks-recon
   /sbin/chkconfig sks-db off
   /sbin/chkconfig --del sks-db
   if [ -f /var/lock/subsys/sks-recon ]; then
      /etc/rc.d/init.d/sks-recon stop
   fi
   if [ -f /var/lock/subsys/sks-db ]; then
      /etc/rc.d/init.d/sks-db stop
   fi
fi


%clean
rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc ANNOUNCEMENT BUGS CHANGELOG COPYING FILES README
%doc TODO VERSION sks_*build.sh sks_*build.bc.sh
%config(noreplace) /etc/logrotate.d/*
%config(noreplace) /etc/sysconfig/*
/etc/rc.d/init.d/*
%dir %attr(750,root,sks) /etc/sks
%config(noreplace) %attr(640,root,sks) /etc/sks/*
/usr/bin/*
/usr/sbin/*
%dir %attr(750,sks,sks) /var/lib/sks
%config(noreplace) %attr(640,sks,sks) /var/lib/sks/.procmailrc
%dir %attr(750,sks,sks) /var/log/sks


%changelog
* Wed Nov 10 2004 peter.pramberger@member.fsf.org
- Current export of my tla archive sks--devel--1.1 (patch-10)

* Thu Jul 15 2004 peter.pramberger@member.fsf.org
- Current export of my tla archive sks--devel--1.1 (patch-7)

* Wed May 12 2004 peter.pramberger@member.fsf.org
- upgrade to DB 4.2

* Mon Mar 15 2004 peter.pramberger@member.fsf.org
- new version 1.0.7-20040315

* Wed Feb 25 2004 peter.pramberger@member.fsf.org
- new version 1.0.6-20040225
- bugfix for output of user attributes on index page
- create logfiles as "name".log to support logrotate script

* Mon Feb 23 2004 peter.pramberger@member.fsf.org
- created

